﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using System.Data;

namespace ASPNETAJAX
{
    public partial class HiddenColumnValue : System.Web.UI.Page
    {
        static int NumberofRow = 25;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                AddBehaviors();
                AddColumnsToGrid();
            }
            BindData();
        }

        private void AddBehaviors()
        {
            WebHierarchicalDataGrid1.Behaviors.CreateBehavior<Infragistics.Web.UI.GridControls.EditingCore>();
            WebHierarchicalDataGrid1.Behaviors.EditingCore.Behaviors.CreateBehavior<Infragistics.Web.UI.GridControls.CellEditing>();

            WebHierarchicalDataGrid1.Behaviors.CreateBehavior<Infragistics.Web.UI.GridControls.EditingCore>();
            WebHierarchicalDataGrid1.Behaviors.EditingCore.Behaviors.CreateBehavior<Infragistics.Web.UI.GridControls.CellEditing>();
        }

        private void AddColumnsToGrid()
        {
            WebHierarchicalDataGrid1.Columns.Clear();
            WebHierarchicalDataGrid1.Columns.Clear();

            //AddCheckBoxColumn("Select", "System.Boolean");
            AddColumn("A1", "A1", "System.String", false);
            AddColumn("A2", "A2", "System.Int64", false);
            AddColumn("Hidden", "Hidden", "System.Int64", true);
            AddColumn("A3", "A3", "System.DateTime", false);
            //AddBoundCheckBoxColumn("A4");
            AddColumn("A5", "A5", "System.String", false);
        }

        private void AddCheckBoxColumn(string columnKey, string dataType)
        {
            UnboundCheckBoxField column = new UnboundCheckBoxField();

            column.Key = columnKey;
            column.HtmlEncode = false;
            column.DataType = dataType;

            column.HeaderCheckBoxMode = Infragistics.Web.UI.CheckBoxMode.TriState;

            column.Header.Text = columnKey;
            column.Width = Unit.Pixel(100);
            //WebDataGrid1.Columns.Add(column);
            WebHierarchicalDataGrid1.Columns.Add(column);
        }

        private void AddColumn(string columnKey, string baseColumn, string dataType, bool isHidden)
        {
            BoundDataField column = new BoundDataField();

            column.Key = columnKey;
            column.DataFieldName = baseColumn;
            column.HtmlEncode = false;
            column.DataType = dataType;
            column.Header.Text = columnKey;

            if (isHidden)
            {
                column.Hidden = true;
            }
            else
            {
                column.Width = Unit.Pixel(100);
            }

            WebHierarchicalDataGrid1.Columns.Add(column);

            EditingColumnSetting ES = new EditingColumnSetting();
            ES.ColumnKey = columnKey;
            ES.ReadOnly = true;
            WebHierarchicalDataGrid1.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(ES);
        }

        private void AddBoundCheckBoxColumn(string columnKey)
        {
            BoundCheckBoxField column = new BoundCheckBoxField();

            column.Key = columnKey;
            column.DataType = "System.Boolean";

            column.Header.Text = columnKey;
            column.Width = Unit.Pixel(100);
            WebHierarchicalDataGrid1.Columns.Add(column);
        }

        private void BindData()
        {

            DataSet ds = GetDataSet();
            WebHierarchicalDataGrid1.AutoGenerateColumns = false;
            WebHierarchicalDataGrid1.DataSource = ds;
            WebHierarchicalDataGrid1.DataMember = "ABC";
            WebHierarchicalDataGrid1.DataKeyFields = "A1";
            //WebHierarchicalDataGrid1.DataMember = "ABC";
            //WebHierarchicalDataGrid1.DataKeyFields = "A1";

            //WebHierarchicalDataGrid1.AutoGenerateBands = false;

            //WebHierarchicalDataGrid1.Bands[0].AutoGenerateColumns = false;
            //WebHierarchicalDataGrid1.Bands[0].DataMember = "XYZ";
            //WebHierarchicalDataGrid1.Bands[0].DataKeyFields = "A1";
            //WebHierarchicalDataGrid1.Bands[0].DataMember = "XYZ";
            //WebHierarchicalDataGrid1.Bands[0].DataKeyFields = "A1";
            //Band band = new Band();


            WebHierarchicalDataGrid1.DataBind();
        }

        private DataSet GetDataSet()
        {
            DataSet ds;
            if (Session["ABCXYZ"] != null)
                ds = (DataSet)Session["ABCXYZ"];
            else
                ds = GenerateDataSet();

            return ds;
        }

        private DataSet GenerateDataSet()
        {
            DataSet ds = new DataSet();
            DataTable dt = GenerateData();
            ds.Tables.Add(dt);

            //if (Hierarchical)
            //{
            //    DataTable dtChild = GenerateChildData();
            //    ds.Tables.Add(dtChild);

            //    DataRelation rel = new DataRelation("Relation", ds.Tables["ABC"].Columns["A1"], ds.Tables["XYZ"].Columns["A1"]);
            //    ds.Relations.Add(rel);

            //    ds.Tables["ABC"].PrimaryKey = new DataColumn[] { ds.Tables["ABC"].Columns["A1"] };

            //    dtChild = GenerateSecondChildData();
            //    ds.Tables.Add(dtChild);

            //    DataRelation rel2 = new DataRelation("Relation2", ds.Tables["ABC"].Columns["A1"], ds.Tables["LKP"].Columns["A1"]);
            //    ds.Relations.Add(rel2);
            //}
            Session["ABCXYZ"] = ds;
            return ds;
        }

        private DataTable GenerateData()
        {
            DataTable dt = new DataTable("ABC");

            dt.Columns.Add(new DataColumn("A1", Type.GetType("System.String")));
            dt.Columns.Add(new DataColumn("A2", Type.GetType("System.Int32")));
            dt.Columns.Add(new DataColumn("A3", Type.GetType("System.DateTime")));
            dt.Columns.Add(new DataColumn("Hidden", Type.GetType("System.String")));
            dt.Columns.Add(new DataColumn("A4", Type.GetType("System.String")));
            dt.Columns.Add(new DataColumn("A5", Type.GetType("System.String")));

            for (int iCounter = 1; iCounter < NumberofRow; iCounter++)
            {
                DataRow dr;

                dr = dt.NewRow();
                //dr["A1"] = "<a href='www.google.co.in'> Y" + iCounter.ToString("00") + "</a>";
                dr["A1"] = "Y" + iCounter.ToString("00");
                dr["A2"] = iCounter;
                dr["Hidden"] = "Hidden " + iCounter;
                dr["A3"] = DateTime.Now.AddDays(iCounter).Date;
                dr["A4"] = ((iCounter / 2) == 0).ToString();
                dr["A5"] = "Active";
                dt.Rows.Add(dr);
            }

            //Session["ABC"] = dt;
            return dt;
        }
    }
}